﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace LogCombiner
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void addFilesButton_Click(object sender, EventArgs e)
        {
            openFileDialog1.DefaultExt = "*.log";
            openFileDialog1.ShowDialog();
        }

        private void outputFileButton_Click(object sender, EventArgs e)
        {
            saveFileDialog1.ShowDialog();
        }

        private void combineLogsButton_Click(object sender, EventArgs e)
        {
            Hashtable logfiles = new Hashtable();
            StringBuilder sb = new StringBuilder();
            TextWriter tw = new StringWriter(sb);
            bool bFinished = false;

            foreach (object filename in logFilesListBox.Items)
            {
                logfiles.Add(filename.ToString(),new LogFile(filename.ToString()));
            }
            while (!bFinished)
            {
                DateTime EarliestTimeStamp = DateTime.MaxValue;
                string CurrFilename=string.Empty;
                foreach (string key in logfiles.Keys)
                {
                    LogFile lf = (LogFile) logfiles[key];
                    if (lf.CurrentTimeStamp < EarliestTimeStamp)
                    {
                        CurrFilename=key;
                        EarliestTimeStamp=lf.CurrentTimeStamp;
                    }
                }
                if (EarliestTimeStamp==DateTime.MaxValue) bFinished=true;
                if (!bFinished)
                {
                    LogFile lf = (LogFile) logfiles[CurrFilename];
                    sb.AppendLine(lf.CurrentLine);
                    lf.ReadLine();
                }
            }
            outputTextBox.Text=sb.ToString();
            if (outputFilenameTextBox.Text!=String.Empty)
            {
                using (FileStream fs = File.OpenWrite(outputFilenameTextBox.Text))
                {
                    byte[] toWrite = System.Text.Encoding.UTF8.GetBytes(sb.ToString());
                    fs.Write(toWrite,0,toWrite.GetLength(0));
                }
            }
        }

        private void openFileDialog1_FileOk(object sender, CancelEventArgs e)
        {
            foreach (string filename in openFileDialog1.FileNames)
            {
                if (!logFilesListBox.Items.Contains(filename))
                {
                    logFilesListBox.Items.Add(filename);
                }
            }
        }

        private void saveFileDialog1_FileOk(object sender, CancelEventArgs e)
        {
            outputFilenameTextBox.Text = saveFileDialog1.FileName;
        }
    }
}
